using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;
using System.IO;

namespace fall2015wintowersdb
{
    public partial class Form1 : Form
    {
        static public string sql;
        static public string constr = "dsn=jkpdsn; name=root; pwd=";
        static public OdbcConnection con;
        static public OdbcCommand cmd;
        static public OdbcDataReader rd;
        static public bool from = true;
        static public bool fail = false;
        static public bool auto = false;
        static public int ring;
        static public int count = 0;
        static public int selectfrom=0, selectto=0;
        static public int[,] fromtower = new int[4, 10];//tower,posision,value = ring
        static public int[,] totower   = new int[4, 10];
        static public int[,] tower     = new int[4, 10];  //tower,position

        public Form1()
        {
            InitializeComponent();
            droptable();
            createtable();
            resetgame();
        }

        private void resetgame()
        {
            int a, b;
            for (a=1;a<4;a++)
            {
                for (b = 1; b < 6; b++)
                {
                    if (a != 1)
                    {
                        tower[a, b] = 0;
                        fromtower[a, b] = 0;
                    }
                    else
                    {
                        tower[a, b] = b;
                        fromtower[a, b] = 0;
                    }
                       
                }
            }
            count=0;
        }

        private void createtable()
        {
            //droptable();
            try
            {
                sql = "CREATE TABLE towers ( ";
                sql += "i int primary key auto_increment, ";
                sql += "data varchar(40));";
                dbw();
            }
            catch
            {
            }
        }

        private void droptable()
        {
            try
            {
                sql = "DROP TABLE towers ;";
                dbw();
            }
            catch
            {
            }
        }

        private void writedata()
        {
            int a;
            string str="";
            for (a = 1; a < 6; a++)
                str += tower[1,a].ToString() + " ";
            for (a = 1; a < 6; a++)
                str += tower[2,a].ToString() + " ";
            for (a = 1; a < 6; a++)
                str += tower[3,a].ToString() + " ";
            sql  = "INSERT INTO towers (data) values ('";
            sql += str;
            sql += "');";
           // MessageBox.Show(sql);
            dbw();
        }
        private void dbw()
        {
            con = new OdbcConnection(constr);
            cmd = new OdbcCommand(sql, con);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }

        private void dbr()
        {
            con = new OdbcConnection(constr);
            cmd = new OdbcCommand(sql, con);
            con.Open();
            rd = cmd.ExecuteReader();
        }

        private void placerings()
        {
            //if(auto==false)
                //writedata();
            if (tower[1,5] == 5)
                textBox5.Location = new Point(173, 225);
            if (tower[1,5] == 4)
                textBox6.Location = new Point(186, 225);
            if (tower[1,5] == 3)
                textBox7.Location = new Point(208, 225);
            if (tower[1,5] == 2)
                textBox8.Location = new Point(223, 225);
            if (tower[1,5] == 1)
                textBox9.Location = new Point(237, 225);
            if (tower[1,4] == 4)
                textBox6.Location = new Point(186, 199);
            if (tower[1,4] == 3)
                textBox7.Location = new Point(208, 199);
            if (tower[1,4] == 2)
                textBox8.Location = new Point(223, 199);
            if (tower[1,4] == 1)
                textBox9.Location = new Point(237, 199);
            if (tower[1,3] == 3)
                textBox7.Location = new Point(208, 173);
            if (tower[1,3] == 2)
                textBox8.Location = new Point(223, 173);
            if (tower[1,3] == 1)
                textBox9.Location = new Point(237, 173);
            if (tower[1,2] == 2)
                textBox8.Location = new Point(223, 147);
            if (tower[1,2] == 1)
                textBox9.Location = new Point(237, 147);
            if (tower[1,1] == 1)
                textBox9.Location = new Point(237, 121);

            if (tower[2,5] == 5)
                textBox5.Location = new Point(173 + 230, 225);
            if (tower[2,5] == 4)
                textBox6.Location = new Point(186 + 230, 225);
            if (tower[2,5] == 3)
                textBox7.Location = new Point(208 + 230, 225);
            if (tower[2,5] == 2)
                textBox8.Location = new Point(223 + 230, 225);
            if (tower[2,5] == 1)
                textBox9.Location = new Point(237 + 230, 225);
            if (tower[2,4] == 4)
                textBox6.Location = new Point(186 + 230, 199);
            if (tower[2,4] == 3)
                textBox7.Location = new Point(208 + 230, 199);
            if (tower[2,4] == 2)
                textBox8.Location = new Point(223 + 230, 199);
            if (tower[2,4] == 1)
                textBox9.Location = new Point(237 + 230, 199);
            if (tower[2,3] == 3)
                textBox7.Location = new Point(208 + 230, 173);
            if (tower[2,3] == 2)
                textBox8.Location = new Point(223 + 230, 173);
            if (tower[2,3] == 1)
                textBox9.Location = new Point(237 + 230, 173);
            if (tower[2,2] == 2)
                textBox8.Location = new Point(223 + 230, 147);
            if (tower[2,2] == 1)
                textBox9.Location = new Point(237 + 230, 147);
            if (tower[2,1] == 1)
                textBox9.Location = new Point(237 + 230, 121);

            if (tower[3,5] == 5)
                textBox5.Location = new Point(173 + 452, 225);
            if (tower[3,5] == 4)
                textBox6.Location = new Point(186 + 452, 225);
            if (tower[3,5] == 3)
                textBox7.Location = new Point(208 + 452, 225);
            if (tower[3,5] == 2)
                textBox8.Location = new Point(223 + 452, 225);
            if (tower[3,5] == 1)
                textBox9.Location = new Point(237 + 452, 225);
            if (tower[3,4] == 4)
                textBox6.Location = new Point(186 + 452, 199);
            if (tower[3,4] == 3)
                textBox7.Location = new Point(208 + 452, 199);
            if (tower[3,4] == 2)
                textBox8.Location = new Point(223 + 452, 199);
            if (tower[3,4] == 1)
                textBox9.Location = new Point(237 + 452, 199);
            if (tower[3,3] == 3)
                textBox7.Location = new Point(208 + 452, 173);
            if (tower[3,3] == 2)
                textBox8.Location = new Point(223 + 452, 173);
            if (tower[3,3] == 1)
                textBox9.Location = new Point(237 + 452, 173);
            if (tower[3,2] == 2)
                textBox8.Location = new Point(223 + 452, 147);
            if (tower[3,2] == 1)
                textBox9.Location = new Point(237 + 452, 147);
            if (tower[3,1] == 1)
                textBox9.Location = new Point(237 + 452, 121);
            textBox10.Text=count.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //Clear
            droptable();
            createtable();
            auto = false;
            from = true;
            fail = false;
            resetgame();
            count=0;
            placerings();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //Auto
            auto = true;
            string line;
            sql = "SELECT * FROM towers ; ";
            dbr();
            while (rd.Read())
            {
                line = rd["data"].ToString();
                //MessageBox.Show(line);
                tower[1,1] = (Convert.ToInt16(line[0])-48);
                tower[1,2] = (Convert.ToInt16(line[2])-48);
                tower[1,3] = (Convert.ToInt16(line[4])-48);
                tower[1,4] = (Convert.ToInt16(line[6])-48);
                tower[1,5] = (Convert.ToInt16(line[8])-48);
                tower[2,1] = (Convert.ToInt16(line[10])-48);
                tower[2,2] = (Convert.ToInt16(line[12])-48);
                tower[2,3] = (Convert.ToInt16(line[14])-48);
                tower[2,4] = (Convert.ToInt16(line[16])-48);
                tower[2,5] = (Convert.ToInt16(line[18])-48);
                tower[3,1] = (Convert.ToInt16(line[20])-48);
                tower[3,2] = (Convert.ToInt16(line[22])-48);
                tower[3,3] = (Convert.ToInt16(line[24])-48);
                tower[3,4] = (Convert.ToInt16(line[26])-48);
                tower[3,5] = (Convert.ToInt16(line[28])-48);
                count++;
                //MessageBox.Show(tower[1, 1].ToString() + " " + tower[1, 2].ToString() + " " + tower[1, 3].ToString() + " " + tower[1, 4].ToString() + " " + tower[1, 5].ToString());
                Thread.Sleep(300);
                placerings();
            }
            rd.Close();
            con.Close();
            auto = false;
        } 

        private void button3_Click(object sender, EventArgs e)
        {
            //Save
            SaveFileDialog sfd1 = new SaveFileDialog();
            sfd1.FileName="defaultsave.txt";
            if (sfd1.ShowDialog() == DialogResult.OK)
            {
                StreamWriter sw = new StreamWriter(sfd1.OpenFile());
                sql = "select * from towers;";
                dbr();
                while(rd.Read())
                {
                    sw.WriteLine(rd["data"].ToString());
                }
                sw.Close();
                con.Close();
                rd.Dispose();
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //Load
            string line;
            OpenFileDialog ofd1 = new OpenFileDialog();
            ofd1.Multiselect = true;
            ofd1.ShowDialog();
            string filename = ofd1.FileName;
            StreamReader sr = new StreamReader(filename);
            while ((line = sr.ReadLine()) != null)
            {
                tower[1, 1] = (Convert.ToInt16(line[0]) - 48);
                tower[1, 2] = (Convert.ToInt16(line[2]) - 48);
                tower[1, 3] = (Convert.ToInt16(line[4]) - 48);
                tower[1, 4] = (Convert.ToInt16(line[6]) - 48);
                tower[1, 5] = (Convert.ToInt16(line[8]) - 48);
                tower[2, 1] = (Convert.ToInt16(line[10]) - 48);
                tower[2, 2] = (Convert.ToInt16(line[12]) - 48);
                tower[2, 3] = (Convert.ToInt16(line[14]) - 48);
                tower[2, 4] = (Convert.ToInt16(line[16]) - 48);
                tower[2, 5] = (Convert.ToInt16(line[18]) - 48);
                tower[3, 1] = (Convert.ToInt16(line[20]) - 48);
                tower[3, 2] = (Convert.ToInt16(line[22]) - 48);
                tower[3, 3] = (Convert.ToInt16(line[24]) - 48);
                tower[3, 4] = (Convert.ToInt16(line[26]) - 48);
                tower[3, 5] = (Convert.ToInt16(line[28]) - 48);
                writedata();
            }
            sr.Close();
        }
        private void getring()
        {
            int i = selectfrom;
            //MessageBox.Show(i +" from true");
            ring = 0;
            if (tower[i, 1] != 0)
            {
                ring = tower[i, 1];
                fromtower[i, 1] = ring;
            }
            else
                if (tower[i, 2] != 0)
                {
                    ring = tower[i, 2];
                    fromtower[i, 2] = ring;
                }
                else
                    if (tower[i, 3] != 0)
                    {
                        ring = tower[i, 3];
                        fromtower[i, 3] = ring;
                    }
                    else
                        if (tower[i, 4] != 0)
                        {
                            ring = tower[i, 4];
                            fromtower[i, 4] = ring;
                        }
                        else
                            if (tower[i, 5] != 0)
                            {
                                ring = tower[i, 5];
                                fromtower[i, 5] = ring;
                            }
            //MessageBox.Show("ring = " + ring.ToString());
        }

        private void putring()
        {
            int i = selectto;

            validate();
            //MessageBox.Show(i + " from false after validate");
            if (fail == false)
            {
                // set in ring to new tower
                if (tower[i, 5] == 0)
                    tower[i, 5] = ring;
                else
                    if (tower[i, 4] == 0)
                        tower[i, 4] = ring;
                    else
                        if (tower[i, 3] == 0)
                            tower[i, 3] = ring;
                        else
                            if (tower[i, 2] == 0)
                                tower[i, 2] = ring;
                            else
                                if (tower[i, 1] == 0)
                                    tower[i, 1] = ring;
                // reset ring from old tower
                i = selectfrom;
                if (fromtower[i, 1] == ring)
                    tower[i, 1] = 0;
                if (fromtower[i, 2] == ring)
                    tower[i, 2] = 0;
                if (fromtower[i, 3] == ring)
                    tower[i, 3] = 0;
                if (fromtower[i, 4] == ring)
                    tower[i, 4] = 0;
                if (fromtower[i, 5] == ring)
                    tower[i, 5] = 0;
                count++;
                writedata();
            }
            else
                MessageBox.Show("Illegal move");

            //reset fromtower
            int a, b;
            for (a = 1; a < 4; a++)
                for (b = 1; b < 6; b++)
                {
                    fromtower[a, b] = 0;
                }

            //show rings
            placerings();
        }

        private void validate()
        {
            int i = selectto;
            fail = false;
            if (ring == 0) fail = true;
            if ((tower[i,1] != 0) && (tower[i,1] < ring)) fail = true;
            if ((tower[i,2] != 0) && (tower[i,2] < ring)) fail = true;
            if ((tower[i,3] != 0) && (tower[i,3] < ring)) fail = true;
            if ((tower[i,4] != 0) && (tower[i,4] < ring)) fail = true;
            if ((tower[i,5] != 0) && (tower[i,5] < ring)) fail = true;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            //Select 1 tower 1
            if(from==true) //take from tower 1
            {
                selectfrom = 1;
                getring();
            }
            else //give to tower 1
            {
                selectto = 1;
                putring();
            }
            if (from == true)
                from = false;
            else
                from = true;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            //Select 2 tower 2
            if (from == true) //take from tower 2
            {
                selectfrom = 2;
                getring();
            }
            else //give to tower 1
            {
                selectto = 2;
                putring();
            }
            if (from == true)
                from = false;
            else
                from = true;

        }

        private void button7_Click(object sender, EventArgs e)
        {
            //Select 3 tower 3
            if (from == true) //take from tower 3
            {
                selectfrom = 3;
                getring();
            }
            if (from == false) //give to tower 3
            {
                selectto = 3;
                putring();
            }
            if (from == true)
                from = false;
            else
                from = true;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {

        }
    }
}